package j2d.filters.fftConvolution;

//package j2d.gui;
//package j2d.filters.bufferedImageConvolution;

import j2d.ImageProcessorInterface;
import j2d.ImageUtils;
import j2d.gui.ImagePanel;
import j2d.filters.bufferedImageConvolution.ImageMatrixBean;
import j2d.border.Utils;

import javax.media.jai.PlanarImage;
import java.awt.*;
import java.awt.image.*;

import gui.ClosableJFrame;
import j2d.filters.fftConvolution.FFTImageAM;

/**
 * Created by Robert Distinti.
 * User: default
 * Date: Sep 23, 2005
 * Time: 9:06:48 PM
 *
 * Revision History:
 * 2005 Oct 23 - Modified by Anne MacIlvain to do homework #6.
 */
public class FFTR2ImageConvolverAM implements ImageProcessorInterface {
    private ImageMatrixBean o;
    //todo hw6 you will need to implement this with an FFT2dR2
    public Image process(Image image) {
        int fftwidth;
        int fftheight;
        BufferedImage bi;
        bi=ImageUtils.getBufferedImage2(image);

        BufferedImageOp op=new ConvolveOp(o.getKernel());

        PlanarImage borderImage = Utils.getBorderImage(ImageUtils.getPlanarImage(bi),
                o.getMatrixSize(),o.getMatrixSize(),o.getMatrixSize(),o.getMatrixSize(),
                o.getBorderType());

        bi=borderImage.getAsBufferedImage();

        // 2005 Oct 23 - Anne MacIlvain - clip image to even power of 2 size
        fftwidth = clipToPowerOfTwo(bi.getWidth());
        fftheight = clipToPowerOfTwo(bi.getHeight());
        BufferedImage fftbi = bi.getSubimage(0,0,fftwidth, fftheight);

        // 2005 Oct 23 - Anne MacIlvain
        byte[][] kernelData = o.getData();
        displayData(kernelData);

        BufferedImage kernelImage = replicateKernel(fftbi, kernelData);

        Image fftImage = FFTImageAM.fft(fftbi, kernelImage);
        displayImage(fftImage,"This is the PSD of the filtered output");

        Image filteredImage = FFTImageAM.filter(fftbi, kernelImage);

        // Question: How do I open a new window in the desktop?
        // How do I get access to main.java's deskTop member variable??
        // I want to display intermediate results, but I can't.
        displayImage(fftImage, "FFT of Image");

        return filteredImage;
    }

    private void displayImage(Image image, String title) {
        //To change body of created methods use File | Settings | File Templates.
        //j2d.gui.Main.getDesktop();
        System.out.println("I am displaying a new frame here!");
        ClosableJFrame cf = new ClosableJFrame(title);
        Container c = cf.getContentPane();
        ImagePanel ip = new ImagePanel();
        ip.setImage(image);
        c.add(ip);
        cf.setSize(255,255);
        cf.setVisible(true);
        
    }

    private BufferedImage replicateKernel(BufferedImage image, byte[][] kernelData) {
        BufferedImage bi = image;
        int rgb;
        int kernel;
        int width = image.getWidth();
        int height = image.getHeight();
        int row = kernelData.length;
        int col = kernelData[0].length;
        for (int ww = 0; ww < width; ww++) {
            for (int hh = 0; hh < height; hh++) {
                kernel = kernelData[ww%row][hh%col];
                if (kernel > 0) {
                    rgb = 0xFFFFFF;
                }
                else {
                    rgb = 0x0;
                }
                bi.setRGB(ww,hh,rgb);
            }
        }
        return bi;  //To change body of created methods use File | Settings | File Templates.
    }

    private int clipToPowerOfTwo(int data) {
        double  exponentTwo = Math.log((double)data)/Math.log(2);
        int     clipped = (int) Math.pow(2,exponentTwo);
        return clipped;  //To change body of created methods use File | Settings | File Templates.
    }

    private void displayData(byte[][] data) {
        //To change body of created methods use File | Settings | File Templates.
        String  text;
        for (int row = 0; row < data.length; row++) {
            text = "";
            for (int col = 0; col < data[0].length; col++) {
                text += String.valueOf(data[row][col]) + " ";
            }
            System.out.println(text);
        }
    }

    public FFTR2ImageConvolverAM(ImageMatrixBean o){
        this.o=o;
    }
}

